//--------------------------------------------------------------------------------
// Background Script - A heart of the extenstion.
//--------------------------------------------------------------------------------

let isEnabled = true;
let USER_ID = "";
let SECRET;
let ffVersion = getVersion();

var SEARCH_DOMAIN = "bright-tab.com";
var EXTENSION = "BrightTab";
var EXTENSION_CODE = 101;
let utm_uid = "";

setTimeout(function(){
    browser.storage.local.get(["secret", "userId", "utm_uid"], function(items) {
        if(items.userId !== undefined)
        {
            USER_ID = items.userId;
        }
        if(items.secret !== undefined)
        {
            SECRET = items.secret;
        }
        if(items.utm_uid !== undefined)
        {
            utm_uid = items.utm_uid;
        }
    });

}, 3000);



function generateUserId() {
    let d = new Date().getTime();
    let uuid = "xxxxxxxx-xxxx-4xxx-xxxxxxxxxxxx".replace(/[xy]/g, function (c) {
        let r = (d + Math.random() * 16) % 16 | 0;
        d = Math.floor(d / 16);
        return (c === "x" ? r : (r & 0x3 | 0x8)).toString(16);
    });
    return uuid;
}

function fireInstallPixel(userId) {
    const url = "http://" + SEARCH_DOMAIN + "/install.php";
    let parameters = {
        uid: userId,
        b: "firefox",
        extension: EXTENSION,
        theme_index: EXTENSION_CODE
    };
    $.post(url, parameters, function(response) {
        let parameters = $.parseJSON(response);
        SECRET = parameters["ch"];
        utm_uid = parameters["utm_uid"];
        browser.storage.local.set({ secret: SECRET, utm_uid: utm_uid });
    });
}

function BuildSearchQuery(query) {

    let queryStringObject = {
        uid: USER_ID,
        rnd: 1,
        themeIndex : EXTENSION_CODE,
        b: "firefox",
        bv: ffVersion,
        secret: SECRET,
        source: 1,
        utm_uid: utm_uid,
    };

    if (query !== undefined && query !== null)
        queryStringObject["q"] = query;

    return $.param(queryStringObject);
}

browser.runtime.onInstalled.addListener(onRuntimeInstalled);

function onRuntimeInstalled(details) {
    if (details.reason === "install")
        onExtensionInstalled();
    else if (details.reason === "update")
        onExtensionUpdated();
}

function onExtensionInstalled(){
    USER_ID = generateUserId();
    browser.storage.local.set({ userId: USER_ID }, function() {
        fireInstallPixel(USER_ID);
    });
    var uninstallURL = "http://" + SEARCH_DOMAIN + "/uninstall.php?&uid=" + USER_ID;
    browser.runtime.setUninstallURL(uninstallURL);
    //browser.storage.local.set({keepChangesShown: false});

    browser.tabs.query({}, function (tabs) {
        for (let i in tabs) {
            if (tabs.hasOwnProperty(i)) {
                tab = tabs[i];
                if (tab.url.indexOf("closetab=yes") !== -1) {
                    browser.tabs.remove(tab.id);
                }
            }
        }
    });
}

function onExtensionUpdated(){
    if(USER_ID === "" || USER_ID === undefined){
        browser.storage.local.get("userId", function(items) {
            if(items.userId === undefined){
                USER_ID = generateUserId();
                browser.storage.local.set({ userId: USER_ID });
                var uninstallURL = "http://" + SEARCH_DOMAIN + "/uninstall.php?&uid=" + USER_ID;
                browser.runtime.setUninstallURL(uninstallURL);
            }
            else{
                USER_ID = items.userId;
            }
        });
    }
}

chrome.webRequest.onBeforeRequest.addListener(
    function (details) {
        var queryString = BuildSearchQuery(null);
        return {redirectUrl: details.url.replace("?", "?" + queryString + "&")};
    },
    {urls: ["*://bright-tab.com/search.php?q=*"]}, ["blocking"]
);

function getVersion() {

    let ua = navigator.userAgent, M = ua.match(/(opera|chrome|safari|firefox|msie|trident(?=\/))\/?\s*(\d+)/i) || [];
    M = M[2] ? [M[1], M[2]] : [navigator.appName, navigator.appVersion, '-?'];
    return M[1];
}
